Package ghidra.util.database

# Class DBCachedObjectStoreSubMap<T extends DBAnnotatedObject>

java.lang.Object
ghidra.util.database.DBCachedObjectStoreMap<T>
ghidra.util.database.DBCachedObjectStoreSubMap<T>

Type Parameters:
  `T` - the type of objects in the store

All Implemented Interfaces:
  `Map<Long,T>`, `NavigableMap<Long,T>`, `SequencedMap<Long,T>`, `SortedMap<Long,T>`

public class DBCachedObjectStoreSubMap<T extends DBAnnotatedObject> extends DBCachedObjectStoreMap<T>
This is the sub-ranged form of `DBCachedObjectStoreMap`

For example, this can be obtained via `store.asMap().subMap(...)`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K,V>`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final KeySpan`
  `keySpan`

  ### Fields inherited from class ghidra.util.database.DBCachedObjectStoreMap

  `direction, errHandler, lock, store`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBCachedObjectStoreSubMap(DBCachedObjectStore<T> store, ErrorHandler errHandler, ReadWriteLock lock, DirectedIterator.Direction direction, KeySpan keySpan)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Map.Entry<Long,T>`
  `ceilingEntry(Long key)`
  `Long`
  `ceilingKey(Long key)`
  `void`
  `clear()`
  `boolean`
  `containsKey(Object key)`
  `boolean`
  `containsValue(Object value)`
  `DBCachedObjectStoreKeySubSet`
  `descendingKeySet()`
  `DBCachedObjectStoreSubMap<T>`
  `descendingMap()`
  `DBCachedObjectStoreEntrySubSet<T>`
  `entrySet()`
  `Map.Entry<Long,T>`
  `firstEntry()`
  `Long`
  `firstKey()`
  `Map.Entry<Long,T>`
  `floorEntry(Long key)`
  `Long`
  `floorKey(Long key)`
  `T`
  `get(Object key)`
  `DBCachedObjectStoreSubMap<T>`
  `headMap(Long toKey, boolean inclusive)`
  `Map.Entry<Long,T>`
  `higherEntry(Long key)`
  `Long`
  `higherKey(Long key)`
  `boolean`
  `isEmpty()`
  `DBCachedObjectStoreKeySubSet`
  `keySet()`
  `Map.Entry<Long,T>`
  `lastEntry()`
  `Long`
  `lastKey()`
  `Map.Entry<Long,T>`
  `lowerEntry(Long key)`
  `Long`
  `lowerKey(Long key)`
  `DBCachedObjectStoreKeySubSet`
  `navigableKeySet()`
  `Map.Entry<Long,T>`
  `pollFirstEntry()`
  `Map.Entry<Long,T>`
  `pollLastEntry()`
  `T`
  `remove(Object key)`
  `int`
  `size()`
  `DBCachedObjectStoreSubMap<T>`
  `subMap(Long fromKey, boolean fromInclusive, Long toKey, boolean toInclusive)`
  `DBCachedObjectStoreSubMap<T>`
  `tailMap(Long fromKey, boolean inclusive)`
  `DBCachedObjectStoreValueSubCollection<T>`
  `values()`

  ### Methods inherited from class ghidra.util.database.DBCachedObjectStoreMap

  `comparator, headMap, put, putAll, subMap, tailMap`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

  ### Methods inherited from interface java.util.NavigableMap

  `reversed`

  ### Methods inherited from interface java.util.SequencedMap

  `sequencedEntrySet, sequencedKeySet, sequencedValues`

  ### Methods inherited from interface java.util.SortedMap

  `putFirst, putLast`

- ## Field Details

  - ### keySpan

    protected final KeySpan keySpan

- ## Constructor Details

  - ### DBCachedObjectStoreSubMap

    public DBCachedObjectStoreSubMap(DBCachedObjectStore<T> store, ErrorHandler errHandler, ReadWriteLock lock, DirectedIterator.Direction direction, KeySpan keySpan)

- ## Method Details

  - ### size

    public int size()
    Specified by:
      `size` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `size` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `isEmpty` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### containsKey

    public boolean containsKey(Object key)
    Specified by:
      `containsKey` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `containsKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### containsValue

    public boolean containsValue(Object value)
    Specified by:
      `containsValue` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `containsValue` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### get

    public T get(Object key)
    Specified by:
      `get` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `get` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### remove

    public T remove(Object key)
    Specified by:
      `remove` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `remove` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Map<Long,T extends DBAnnotatedObject>`
    Overrides:
      `clear` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### firstEntry

    public Map.Entry<Long,T> firstEntry()
    Specified by:
      `firstEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Specified by:
      `firstEntry` in interface `SequencedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `firstEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### firstKey

    public Long firstKey()
    Specified by:
      `firstKey` in interface `SortedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `firstKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### lastEntry

    public Map.Entry<Long,T> lastEntry()
    Specified by:
      `lastEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Specified by:
      `lastEntry` in interface `SequencedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `lastEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### lastKey

    public Long lastKey()
    Specified by:
      `lastKey` in interface `SortedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `lastKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### lowerEntry

    public Map.Entry<Long,T> lowerEntry(Long key)
    Specified by:
      `lowerEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `lowerEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### lowerKey

    public Long lowerKey(Long key)
    Specified by:
      `lowerKey` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `lowerKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### floorEntry

    public Map.Entry<Long,T> floorEntry(Long key)
    Specified by:
      `floorEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `floorEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### floorKey

    public Long floorKey(Long key)
    Specified by:
      `floorKey` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `floorKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### ceilingEntry

    public Map.Entry<Long,T> ceilingEntry(Long key)
    Specified by:
      `ceilingEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `ceilingEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### ceilingKey

    public Long ceilingKey(Long key)
    Specified by:
      `ceilingKey` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `ceilingKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### higherEntry

    public Map.Entry<Long,T> higherEntry(Long key)
    Specified by:
      `higherEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `higherEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### higherKey

    public Long higherKey(Long key)
    Specified by:
      `higherKey` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `higherKey` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### pollFirstEntry

    public Map.Entry<Long,T> pollFirstEntry()
    Specified by:
      `pollFirstEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Specified by:
      `pollFirstEntry` in interface `SequencedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `pollFirstEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### pollLastEntry

    public Map.Entry<Long,T> pollLastEntry()
    Specified by:
      `pollLastEntry` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Specified by:
      `pollLastEntry` in interface `SequencedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `pollLastEntry` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### keySet

    public DBCachedObjectStoreKeySubSet keySet()
    Specified by:
      `keySet` in interface `Map<Long,T extends DBAnnotatedObject>`
    Specified by:
      `keySet` in interface `SortedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `keySet` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### values

    public DBCachedObjectStoreValueSubCollection<T> values()
    Specified by:
      `values` in interface `Map<Long,T extends DBAnnotatedObject>`
    Specified by:
      `values` in interface `SortedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `values` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### entrySet

    public DBCachedObjectStoreEntrySubSet<T> entrySet()
    Specified by:
      `entrySet` in interface `Map<Long,T extends DBAnnotatedObject>`
    Specified by:
      `entrySet` in interface `SortedMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `entrySet` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### descendingMap

    public DBCachedObjectStoreSubMap<T> descendingMap()
    Specified by:
      `descendingMap` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `descendingMap` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### navigableKeySet

    public DBCachedObjectStoreKeySubSet navigableKeySet()
    Specified by:
      `navigableKeySet` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `navigableKeySet` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### descendingKeySet

    public DBCachedObjectStoreKeySubSet descendingKeySet()
    Specified by:
      `descendingKeySet` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `descendingKeySet` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### subMap

    public DBCachedObjectStoreSubMap<T> subMap(Long fromKey, boolean fromInclusive, Long toKey, boolean toInclusive)
    Specified by:
      `subMap` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `subMap` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### headMap

    public DBCachedObjectStoreSubMap<T> headMap(Long toKey, boolean inclusive)
    Specified by:
      `headMap` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `headMap` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`

  - ### tailMap

    public DBCachedObjectStoreSubMap<T> tailMap(Long fromKey, boolean inclusive)
    Specified by:
      `tailMap` in interface `NavigableMap<Long,T extends DBAnnotatedObject>`
    Overrides:
      `tailMap` in class `DBCachedObjectStoreMap<T extends DBAnnotatedObject>`